/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_DECISION4LONG_H
#define DPC_IMPL_TYPE_DECISION4LONG_H

#include <cfloat>
#include <cmath>
#include "impl_type_float.h"
#include "impl_type_uint8.h"
#include "impl_type_boolean.h"
#include "impl_type_uint32.h"

namespace dpc {
struct Decision4Long {
    ::Float ba_trp_d_lne_view_rngl{ 0.0F };
    ::Float ba_trp_d_lne_view_rngr{ 0.0F };
    ::Float ba_trp_indx_c2_lne_l{ 0.0F };
    ::Float ba_trp_indx_c2_lne_r{ 0.0F };
    ::Float ba_trp_indx_c3_lne_l{ 0.0F };
    ::Float ba_trp_indx_c3_lne_r{ 0.0F };
    ::UInt8 ba_trp_indx_spdlim_typ{ 0U };
    ::Float ba_trp_kmh_spdlim_act_val{ 0.0F };
    ::Float ba_trp_d_spdlim_nxt_dst{ 0.0F };
    ::Float ba_trp_t_tm_gap_actu{ 0.0F };
    ::Float ba_trp_v_sv_setspd{ 0.0F };
    ::Float ba_trp_d_tgt_longt_dist_iv{ 0.0F };
    ::Float ba_trp_d_tgt_lat_dist_iv{ 0.0F };
    ::Float ba_trp_v_tgt_longt_spd_iv{ 0.0F };
    ::Float ba_trp_v_tgt_lat_spd_iv{ 0.0F };
    ::Float ba_trp_v_tgt_rlt_spd_iv{ 0.0F };
    ::Boolean ba_trp_is_tgt_prsnt_iv{ false };
    ::Float ba_trp_t_tgt_dur_tm_iv{ 0.0F };
    ::UInt32 ba_trp_indx_tgt_id_iv{ 0U };
    ::Float ba_trp_a_tgt_longt_accel_iv{ 0.0F };
    ::Float ba_trp_a_tgt_lat_accel_iv{ 0.0F };
    ::UInt8 ba_trp_indx_tgt_typ_iv{ 0U };
    ::Boolean ba_trp_is_tgt_new_iv{ false };
    ::Boolean ba_trp_is_tgt_lne_chg_flag_iv{ false };
    ::Float ba_trp_d_tgt_longt_dist_iiv{ 0.0F };
    ::Float ba_trp_d_tgt_lat_dist_iiv{ 0.0F };
    ::Float ba_trp_v_tgt_longt_spd_iiv{ 0.0F };
    ::Float ba_trp_v_tgt_lat_spd_iiv{ 0.0F };
    ::Float ba_trp_v_tgt_rlt_spd_iiv{ 0.0F };
    ::Boolean ba_trp_is_tgt_prsnt_iiv{ false };
    ::Float ba_trp_t_tgt_dur_tm_iiv{ 0.0F };
    ::UInt32 ba_trp_indx_tgt_id_iiv{ 0U };
    ::Float ba_trp_a_tgt_longt_accel_iiv{ 0.0F };
    ::Float ba_trp_a_tgt_lat_accel_iiv{ 0.0F };
    ::UInt8 ba_trp_indx_tgt_typ_iiv{ 0U };
    ::Boolean ba_trp_is_tgt_new_iiv{ false };
    ::Boolean ba_trp_is_tgt_lne_chg_flag_iiv{ false };
    ::Float ba_trp_d_tgt_longt_dist_flniv{ 0.0F };
    ::Float ba_trp_d_tgt_lat_dist_flniv{ 0.0F };
    ::Float ba_trp_v_tgt_longt_spd_flniv{ 0.0F };
    ::Float ba_trp_v_tgt_lat_spd_flniv{ 0.0F };
    ::Float ba_trp_v_tgt_rlt_spd_flniv{ 0.0F };
    ::Boolean ba_trp_is_tgt_prsnt_flniv{ false };
    ::Float ba_trp_t_tgt_dur_tm_flniv{ 0.0F };
    ::UInt32 ba_trp_indx_tgt_id_flniv{ 0U };
    ::Float ba_trp_a_tgt_longt_accel_flniv{ 0.0F };
    ::Float ba_trp_a_tgt_lat_accel_flniv{ 0.0F };
    ::UInt8 ba_trp_indx_tgt_typ_flniv{ 0U };
    ::Boolean ba_trp_is_tgt_new_flniv{ false };
    ::Boolean ba_trp_is_tgt_cutin_flag_flniv{ false };
    ::Float ba_trp_d_tgt_longt_dist_slniv{ 0.0F };
    ::Float ba_trp_d_tgt_lat_dist_slniv{ 0.0F };
    ::Float ba_trp_v_tgt_longt_spd_slniv{ 0.0F };
    ::Float ba_trp_v_tgt_lat_spd_slniv{ 0.0F };
    ::Float ba_trp_v_tgt_rlt_spd_slniv{ 0.0F };
    ::Float ba_trp_is_tgt_prsnt_slniv{ 0.0F };
    ::Float ba_trp_t_tgt_dur_tm_slniv{ 0.0F };
    ::UInt32 ba_trp_indx_tgt_id_slniv{ 0U };
    ::Float ba_trp_a_tgt_longt_accel_slniv{ 0.0F };
    ::Float ba_trp_a_tgt_lat_accel_slniv{ 0.0F };
    ::UInt8 ba_trp_indx_tgt_typ_slniv{ 0U };
    ::Boolean ba_trp_is_tgt_new_slniv{ false };
    ::Boolean ba_trp_is_tgt_cutin_flag_slniv{ false };
    ::Boolean ba_trp_is_esaa{ false };
    ::UInt8 ba_trp_indx_trp_lgt_sts{ 0U };
    ::Float ba_trp_d_blue_crrdr_dist{ 0.0F };
    ::Float ba_trp_v_blue_crrdr_spd{ 0.0F };
    ::Float ba_trp_v_trgt_spd{ 0.0F };
    ::Float ba_trp_d_related_dist_of_trgt_spd{ 0.0F };
    ::Float ba_trp_d_yllw_brdr_dist{ 0.0F };
    ::Float ba_trp_v_yllw_brdr_spd{ 0.0F };
    ::Float ba_trp_d_red_brdr_dist{ 0.0F };
    ::Float ba_trp_v_red_brdr_spd{ 0.0F };
    ::UInt32 ba_trp_indx_blue_crrdr_tgt_id{ 0U };
    ::Boolean ba_trp_is_blue_crrdr_obj_exist{ false };
    ::UInt8 ba_trp_indx_opt_action{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ba_trp_d_lne_view_rngl);
        fun(ba_trp_d_lne_view_rngr);
        fun(ba_trp_indx_c2_lne_l);
        fun(ba_trp_indx_c2_lne_r);
        fun(ba_trp_indx_c3_lne_l);
        fun(ba_trp_indx_c3_lne_r);
        fun(ba_trp_indx_spdlim_typ);
        fun(ba_trp_kmh_spdlim_act_val);
        fun(ba_trp_d_spdlim_nxt_dst);
        fun(ba_trp_t_tm_gap_actu);
        fun(ba_trp_v_sv_setspd);
        fun(ba_trp_d_tgt_longt_dist_iv);
        fun(ba_trp_d_tgt_lat_dist_iv);
        fun(ba_trp_v_tgt_longt_spd_iv);
        fun(ba_trp_v_tgt_lat_spd_iv);
        fun(ba_trp_v_tgt_rlt_spd_iv);
        fun(ba_trp_is_tgt_prsnt_iv);
        fun(ba_trp_t_tgt_dur_tm_iv);
        fun(ba_trp_indx_tgt_id_iv);
        fun(ba_trp_a_tgt_longt_accel_iv);
        fun(ba_trp_a_tgt_lat_accel_iv);
        fun(ba_trp_indx_tgt_typ_iv);
        fun(ba_trp_is_tgt_new_iv);
        fun(ba_trp_is_tgt_lne_chg_flag_iv);
        fun(ba_trp_d_tgt_longt_dist_iiv);
        fun(ba_trp_d_tgt_lat_dist_iiv);
        fun(ba_trp_v_tgt_longt_spd_iiv);
        fun(ba_trp_v_tgt_lat_spd_iiv);
        fun(ba_trp_v_tgt_rlt_spd_iiv);
        fun(ba_trp_is_tgt_prsnt_iiv);
        fun(ba_trp_t_tgt_dur_tm_iiv);
        fun(ba_trp_indx_tgt_id_iiv);
        fun(ba_trp_a_tgt_longt_accel_iiv);
        fun(ba_trp_a_tgt_lat_accel_iiv);
        fun(ba_trp_indx_tgt_typ_iiv);
        fun(ba_trp_is_tgt_new_iiv);
        fun(ba_trp_is_tgt_lne_chg_flag_iiv);
        fun(ba_trp_d_tgt_longt_dist_flniv);
        fun(ba_trp_d_tgt_lat_dist_flniv);
        fun(ba_trp_v_tgt_longt_spd_flniv);
        fun(ba_trp_v_tgt_lat_spd_flniv);
        fun(ba_trp_v_tgt_rlt_spd_flniv);
        fun(ba_trp_is_tgt_prsnt_flniv);
        fun(ba_trp_t_tgt_dur_tm_flniv);
        fun(ba_trp_indx_tgt_id_flniv);
        fun(ba_trp_a_tgt_longt_accel_flniv);
        fun(ba_trp_a_tgt_lat_accel_flniv);
        fun(ba_trp_indx_tgt_typ_flniv);
        fun(ba_trp_is_tgt_new_flniv);
        fun(ba_trp_is_tgt_cutin_flag_flniv);
        fun(ba_trp_d_tgt_longt_dist_slniv);
        fun(ba_trp_d_tgt_lat_dist_slniv);
        fun(ba_trp_v_tgt_longt_spd_slniv);
        fun(ba_trp_v_tgt_lat_spd_slniv);
        fun(ba_trp_v_tgt_rlt_spd_slniv);
        fun(ba_trp_is_tgt_prsnt_slniv);
        fun(ba_trp_t_tgt_dur_tm_slniv);
        fun(ba_trp_indx_tgt_id_slniv);
        fun(ba_trp_a_tgt_longt_accel_slniv);
        fun(ba_trp_a_tgt_lat_accel_slniv);
        fun(ba_trp_indx_tgt_typ_slniv);
        fun(ba_trp_is_tgt_new_slniv);
        fun(ba_trp_is_tgt_cutin_flag_slniv);
        fun(ba_trp_is_esaa);
        fun(ba_trp_indx_trp_lgt_sts);
        fun(ba_trp_d_blue_crrdr_dist);
        fun(ba_trp_v_blue_crrdr_spd);
        fun(ba_trp_v_trgt_spd);
        fun(ba_trp_d_related_dist_of_trgt_spd);
        fun(ba_trp_d_yllw_brdr_dist);
        fun(ba_trp_v_yllw_brdr_spd);
        fun(ba_trp_d_red_brdr_dist);
        fun(ba_trp_v_red_brdr_spd);
        fun(ba_trp_indx_blue_crrdr_tgt_id);
        fun(ba_trp_is_blue_crrdr_obj_exist);
        fun(ba_trp_indx_opt_action);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ba_trp_d_lne_view_rngl);
        fun(ba_trp_d_lne_view_rngr);
        fun(ba_trp_indx_c2_lne_l);
        fun(ba_trp_indx_c2_lne_r);
        fun(ba_trp_indx_c3_lne_l);
        fun(ba_trp_indx_c3_lne_r);
        fun(ba_trp_indx_spdlim_typ);
        fun(ba_trp_kmh_spdlim_act_val);
        fun(ba_trp_d_spdlim_nxt_dst);
        fun(ba_trp_t_tm_gap_actu);
        fun(ba_trp_v_sv_setspd);
        fun(ba_trp_d_tgt_longt_dist_iv);
        fun(ba_trp_d_tgt_lat_dist_iv);
        fun(ba_trp_v_tgt_longt_spd_iv);
        fun(ba_trp_v_tgt_lat_spd_iv);
        fun(ba_trp_v_tgt_rlt_spd_iv);
        fun(ba_trp_is_tgt_prsnt_iv);
        fun(ba_trp_t_tgt_dur_tm_iv);
        fun(ba_trp_indx_tgt_id_iv);
        fun(ba_trp_a_tgt_longt_accel_iv);
        fun(ba_trp_a_tgt_lat_accel_iv);
        fun(ba_trp_indx_tgt_typ_iv);
        fun(ba_trp_is_tgt_new_iv);
        fun(ba_trp_is_tgt_lne_chg_flag_iv);
        fun(ba_trp_d_tgt_longt_dist_iiv);
        fun(ba_trp_d_tgt_lat_dist_iiv);
        fun(ba_trp_v_tgt_longt_spd_iiv);
        fun(ba_trp_v_tgt_lat_spd_iiv);
        fun(ba_trp_v_tgt_rlt_spd_iiv);
        fun(ba_trp_is_tgt_prsnt_iiv);
        fun(ba_trp_t_tgt_dur_tm_iiv);
        fun(ba_trp_indx_tgt_id_iiv);
        fun(ba_trp_a_tgt_longt_accel_iiv);
        fun(ba_trp_a_tgt_lat_accel_iiv);
        fun(ba_trp_indx_tgt_typ_iiv);
        fun(ba_trp_is_tgt_new_iiv);
        fun(ba_trp_is_tgt_lne_chg_flag_iiv);
        fun(ba_trp_d_tgt_longt_dist_flniv);
        fun(ba_trp_d_tgt_lat_dist_flniv);
        fun(ba_trp_v_tgt_longt_spd_flniv);
        fun(ba_trp_v_tgt_lat_spd_flniv);
        fun(ba_trp_v_tgt_rlt_spd_flniv);
        fun(ba_trp_is_tgt_prsnt_flniv);
        fun(ba_trp_t_tgt_dur_tm_flniv);
        fun(ba_trp_indx_tgt_id_flniv);
        fun(ba_trp_a_tgt_longt_accel_flniv);
        fun(ba_trp_a_tgt_lat_accel_flniv);
        fun(ba_trp_indx_tgt_typ_flniv);
        fun(ba_trp_is_tgt_new_flniv);
        fun(ba_trp_is_tgt_cutin_flag_flniv);
        fun(ba_trp_d_tgt_longt_dist_slniv);
        fun(ba_trp_d_tgt_lat_dist_slniv);
        fun(ba_trp_v_tgt_longt_spd_slniv);
        fun(ba_trp_v_tgt_lat_spd_slniv);
        fun(ba_trp_v_tgt_rlt_spd_slniv);
        fun(ba_trp_is_tgt_prsnt_slniv);
        fun(ba_trp_t_tgt_dur_tm_slniv);
        fun(ba_trp_indx_tgt_id_slniv);
        fun(ba_trp_a_tgt_longt_accel_slniv);
        fun(ba_trp_a_tgt_lat_accel_slniv);
        fun(ba_trp_indx_tgt_typ_slniv);
        fun(ba_trp_is_tgt_new_slniv);
        fun(ba_trp_is_tgt_cutin_flag_slniv);
        fun(ba_trp_is_esaa);
        fun(ba_trp_indx_trp_lgt_sts);
        fun(ba_trp_d_blue_crrdr_dist);
        fun(ba_trp_v_blue_crrdr_spd);
        fun(ba_trp_v_trgt_spd);
        fun(ba_trp_d_related_dist_of_trgt_spd);
        fun(ba_trp_d_yllw_brdr_dist);
        fun(ba_trp_v_yllw_brdr_spd);
        fun(ba_trp_d_red_brdr_dist);
        fun(ba_trp_v_red_brdr_spd);
        fun(ba_trp_indx_blue_crrdr_tgt_id);
        fun(ba_trp_is_blue_crrdr_obj_exist);
        fun(ba_trp_indx_opt_action);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ba_trp_d_lne_view_rngl", ba_trp_d_lne_view_rngl);
        fun("ba_trp_d_lne_view_rngr", ba_trp_d_lne_view_rngr);
        fun("ba_trp_indx_c2_lne_l", ba_trp_indx_c2_lne_l);
        fun("ba_trp_indx_c2_lne_r", ba_trp_indx_c2_lne_r);
        fun("ba_trp_indx_c3_lne_l", ba_trp_indx_c3_lne_l);
        fun("ba_trp_indx_c3_lne_r", ba_trp_indx_c3_lne_r);
        fun("ba_trp_indx_spdlim_typ", ba_trp_indx_spdlim_typ);
        fun("ba_trp_kmh_spdlim_act_val", ba_trp_kmh_spdlim_act_val);
        fun("ba_trp_d_spdlim_nxt_dst", ba_trp_d_spdlim_nxt_dst);
        fun("ba_trp_t_tm_gap_actu", ba_trp_t_tm_gap_actu);
        fun("ba_trp_v_sv_setspd", ba_trp_v_sv_setspd);
        fun("ba_trp_d_tgt_longt_dist_iv", ba_trp_d_tgt_longt_dist_iv);
        fun("ba_trp_d_tgt_lat_dist_iv", ba_trp_d_tgt_lat_dist_iv);
        fun("ba_trp_v_tgt_longt_spd_iv", ba_trp_v_tgt_longt_spd_iv);
        fun("ba_trp_v_tgt_lat_spd_iv", ba_trp_v_tgt_lat_spd_iv);
        fun("ba_trp_v_tgt_rlt_spd_iv", ba_trp_v_tgt_rlt_spd_iv);
        fun("ba_trp_is_tgt_prsnt_iv", ba_trp_is_tgt_prsnt_iv);
        fun("ba_trp_t_tgt_dur_tm_iv", ba_trp_t_tgt_dur_tm_iv);
        fun("ba_trp_indx_tgt_id_iv", ba_trp_indx_tgt_id_iv);
        fun("ba_trp_a_tgt_longt_accel_iv", ba_trp_a_tgt_longt_accel_iv);
        fun("ba_trp_a_tgt_lat_accel_iv", ba_trp_a_tgt_lat_accel_iv);
        fun("ba_trp_indx_tgt_typ_iv", ba_trp_indx_tgt_typ_iv);
        fun("ba_trp_is_tgt_new_iv", ba_trp_is_tgt_new_iv);
        fun("ba_trp_is_tgt_lne_chg_flag_iv", ba_trp_is_tgt_lne_chg_flag_iv);
        fun("ba_trp_d_tgt_longt_dist_iiv", ba_trp_d_tgt_longt_dist_iiv);
        fun("ba_trp_d_tgt_lat_dist_iiv", ba_trp_d_tgt_lat_dist_iiv);
        fun("ba_trp_v_tgt_longt_spd_iiv", ba_trp_v_tgt_longt_spd_iiv);
        fun("ba_trp_v_tgt_lat_spd_iiv", ba_trp_v_tgt_lat_spd_iiv);
        fun("ba_trp_v_tgt_rlt_spd_iiv", ba_trp_v_tgt_rlt_spd_iiv);
        fun("ba_trp_is_tgt_prsnt_iiv", ba_trp_is_tgt_prsnt_iiv);
        fun("ba_trp_t_tgt_dur_tm_iiv", ba_trp_t_tgt_dur_tm_iiv);
        fun("ba_trp_indx_tgt_id_iiv", ba_trp_indx_tgt_id_iiv);
        fun("ba_trp_a_tgt_longt_accel_iiv", ba_trp_a_tgt_longt_accel_iiv);
        fun("ba_trp_a_tgt_lat_accel_iiv", ba_trp_a_tgt_lat_accel_iiv);
        fun("ba_trp_indx_tgt_typ_iiv", ba_trp_indx_tgt_typ_iiv);
        fun("ba_trp_is_tgt_new_iiv", ba_trp_is_tgt_new_iiv);
        fun("ba_trp_is_tgt_lne_chg_flag_iiv", ba_trp_is_tgt_lne_chg_flag_iiv);
        fun("ba_trp_d_tgt_longt_dist_flniv", ba_trp_d_tgt_longt_dist_flniv);
        fun("ba_trp_d_tgt_lat_dist_flniv", ba_trp_d_tgt_lat_dist_flniv);
        fun("ba_trp_v_tgt_longt_spd_flniv", ba_trp_v_tgt_longt_spd_flniv);
        fun("ba_trp_v_tgt_lat_spd_flniv", ba_trp_v_tgt_lat_spd_flniv);
        fun("ba_trp_v_tgt_rlt_spd_flniv", ba_trp_v_tgt_rlt_spd_flniv);
        fun("ba_trp_is_tgt_prsnt_flniv", ba_trp_is_tgt_prsnt_flniv);
        fun("ba_trp_t_tgt_dur_tm_flniv", ba_trp_t_tgt_dur_tm_flniv);
        fun("ba_trp_indx_tgt_id_flniv", ba_trp_indx_tgt_id_flniv);
        fun("ba_trp_a_tgt_longt_accel_flniv", ba_trp_a_tgt_longt_accel_flniv);
        fun("ba_trp_a_tgt_lat_accel_flniv", ba_trp_a_tgt_lat_accel_flniv);
        fun("ba_trp_indx_tgt_typ_flniv", ba_trp_indx_tgt_typ_flniv);
        fun("ba_trp_is_tgt_new_flniv", ba_trp_is_tgt_new_flniv);
        fun("ba_trp_is_tgt_cutin_flag_flniv", ba_trp_is_tgt_cutin_flag_flniv);
        fun("ba_trp_d_tgt_longt_dist_slniv", ba_trp_d_tgt_longt_dist_slniv);
        fun("ba_trp_d_tgt_lat_dist_slniv", ba_trp_d_tgt_lat_dist_slniv);
        fun("ba_trp_v_tgt_longt_spd_slniv", ba_trp_v_tgt_longt_spd_slniv);
        fun("ba_trp_v_tgt_lat_spd_slniv", ba_trp_v_tgt_lat_spd_slniv);
        fun("ba_trp_v_tgt_rlt_spd_slniv", ba_trp_v_tgt_rlt_spd_slniv);
        fun("ba_trp_is_tgt_prsnt_slniv", ba_trp_is_tgt_prsnt_slniv);
        fun("ba_trp_t_tgt_dur_tm_slniv", ba_trp_t_tgt_dur_tm_slniv);
        fun("ba_trp_indx_tgt_id_slniv", ba_trp_indx_tgt_id_slniv);
        fun("ba_trp_a_tgt_longt_accel_slniv", ba_trp_a_tgt_longt_accel_slniv);
        fun("ba_trp_a_tgt_lat_accel_slniv", ba_trp_a_tgt_lat_accel_slniv);
        fun("ba_trp_indx_tgt_typ_slniv", ba_trp_indx_tgt_typ_slniv);
        fun("ba_trp_is_tgt_new_slniv", ba_trp_is_tgt_new_slniv);
        fun("ba_trp_is_tgt_cutin_flag_slniv", ba_trp_is_tgt_cutin_flag_slniv);
        fun("ba_trp_is_esaa", ba_trp_is_esaa);
        fun("ba_trp_indx_trp_lgt_sts", ba_trp_indx_trp_lgt_sts);
        fun("ba_trp_d_blue_crrdr_dist", ba_trp_d_blue_crrdr_dist);
        fun("ba_trp_v_blue_crrdr_spd", ba_trp_v_blue_crrdr_spd);
        fun("ba_trp_v_trgt_spd", ba_trp_v_trgt_spd);
        fun("ba_trp_d_related_dist_of_trgt_spd", ba_trp_d_related_dist_of_trgt_spd);
        fun("ba_trp_d_yllw_brdr_dist", ba_trp_d_yllw_brdr_dist);
        fun("ba_trp_v_yllw_brdr_spd", ba_trp_v_yllw_brdr_spd);
        fun("ba_trp_d_red_brdr_dist", ba_trp_d_red_brdr_dist);
        fun("ba_trp_v_red_brdr_spd", ba_trp_v_red_brdr_spd);
        fun("ba_trp_indx_blue_crrdr_tgt_id", ba_trp_indx_blue_crrdr_tgt_id);
        fun("ba_trp_is_blue_crrdr_obj_exist", ba_trp_is_blue_crrdr_obj_exist);
        fun("ba_trp_indx_opt_action", ba_trp_indx_opt_action);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ba_trp_d_lne_view_rngl", ba_trp_d_lne_view_rngl);
        fun("ba_trp_d_lne_view_rngr", ba_trp_d_lne_view_rngr);
        fun("ba_trp_indx_c2_lne_l", ba_trp_indx_c2_lne_l);
        fun("ba_trp_indx_c2_lne_r", ba_trp_indx_c2_lne_r);
        fun("ba_trp_indx_c3_lne_l", ba_trp_indx_c3_lne_l);
        fun("ba_trp_indx_c3_lne_r", ba_trp_indx_c3_lne_r);
        fun("ba_trp_indx_spdlim_typ", ba_trp_indx_spdlim_typ);
        fun("ba_trp_kmh_spdlim_act_val", ba_trp_kmh_spdlim_act_val);
        fun("ba_trp_d_spdlim_nxt_dst", ba_trp_d_spdlim_nxt_dst);
        fun("ba_trp_t_tm_gap_actu", ba_trp_t_tm_gap_actu);
        fun("ba_trp_v_sv_setspd", ba_trp_v_sv_setspd);
        fun("ba_trp_d_tgt_longt_dist_iv", ba_trp_d_tgt_longt_dist_iv);
        fun("ba_trp_d_tgt_lat_dist_iv", ba_trp_d_tgt_lat_dist_iv);
        fun("ba_trp_v_tgt_longt_spd_iv", ba_trp_v_tgt_longt_spd_iv);
        fun("ba_trp_v_tgt_lat_spd_iv", ba_trp_v_tgt_lat_spd_iv);
        fun("ba_trp_v_tgt_rlt_spd_iv", ba_trp_v_tgt_rlt_spd_iv);
        fun("ba_trp_is_tgt_prsnt_iv", ba_trp_is_tgt_prsnt_iv);
        fun("ba_trp_t_tgt_dur_tm_iv", ba_trp_t_tgt_dur_tm_iv);
        fun("ba_trp_indx_tgt_id_iv", ba_trp_indx_tgt_id_iv);
        fun("ba_trp_a_tgt_longt_accel_iv", ba_trp_a_tgt_longt_accel_iv);
        fun("ba_trp_a_tgt_lat_accel_iv", ba_trp_a_tgt_lat_accel_iv);
        fun("ba_trp_indx_tgt_typ_iv", ba_trp_indx_tgt_typ_iv);
        fun("ba_trp_is_tgt_new_iv", ba_trp_is_tgt_new_iv);
        fun("ba_trp_is_tgt_lne_chg_flag_iv", ba_trp_is_tgt_lne_chg_flag_iv);
        fun("ba_trp_d_tgt_longt_dist_iiv", ba_trp_d_tgt_longt_dist_iiv);
        fun("ba_trp_d_tgt_lat_dist_iiv", ba_trp_d_tgt_lat_dist_iiv);
        fun("ba_trp_v_tgt_longt_spd_iiv", ba_trp_v_tgt_longt_spd_iiv);
        fun("ba_trp_v_tgt_lat_spd_iiv", ba_trp_v_tgt_lat_spd_iiv);
        fun("ba_trp_v_tgt_rlt_spd_iiv", ba_trp_v_tgt_rlt_spd_iiv);
        fun("ba_trp_is_tgt_prsnt_iiv", ba_trp_is_tgt_prsnt_iiv);
        fun("ba_trp_t_tgt_dur_tm_iiv", ba_trp_t_tgt_dur_tm_iiv);
        fun("ba_trp_indx_tgt_id_iiv", ba_trp_indx_tgt_id_iiv);
        fun("ba_trp_a_tgt_longt_accel_iiv", ba_trp_a_tgt_longt_accel_iiv);
        fun("ba_trp_a_tgt_lat_accel_iiv", ba_trp_a_tgt_lat_accel_iiv);
        fun("ba_trp_indx_tgt_typ_iiv", ba_trp_indx_tgt_typ_iiv);
        fun("ba_trp_is_tgt_new_iiv", ba_trp_is_tgt_new_iiv);
        fun("ba_trp_is_tgt_lne_chg_flag_iiv", ba_trp_is_tgt_lne_chg_flag_iiv);
        fun("ba_trp_d_tgt_longt_dist_flniv", ba_trp_d_tgt_longt_dist_flniv);
        fun("ba_trp_d_tgt_lat_dist_flniv", ba_trp_d_tgt_lat_dist_flniv);
        fun("ba_trp_v_tgt_longt_spd_flniv", ba_trp_v_tgt_longt_spd_flniv);
        fun("ba_trp_v_tgt_lat_spd_flniv", ba_trp_v_tgt_lat_spd_flniv);
        fun("ba_trp_v_tgt_rlt_spd_flniv", ba_trp_v_tgt_rlt_spd_flniv);
        fun("ba_trp_is_tgt_prsnt_flniv", ba_trp_is_tgt_prsnt_flniv);
        fun("ba_trp_t_tgt_dur_tm_flniv", ba_trp_t_tgt_dur_tm_flniv);
        fun("ba_trp_indx_tgt_id_flniv", ba_trp_indx_tgt_id_flniv);
        fun("ba_trp_a_tgt_longt_accel_flniv", ba_trp_a_tgt_longt_accel_flniv);
        fun("ba_trp_a_tgt_lat_accel_flniv", ba_trp_a_tgt_lat_accel_flniv);
        fun("ba_trp_indx_tgt_typ_flniv", ba_trp_indx_tgt_typ_flniv);
        fun("ba_trp_is_tgt_new_flniv", ba_trp_is_tgt_new_flniv);
        fun("ba_trp_is_tgt_cutin_flag_flniv", ba_trp_is_tgt_cutin_flag_flniv);
        fun("ba_trp_d_tgt_longt_dist_slniv", ba_trp_d_tgt_longt_dist_slniv);
        fun("ba_trp_d_tgt_lat_dist_slniv", ba_trp_d_tgt_lat_dist_slniv);
        fun("ba_trp_v_tgt_longt_spd_slniv", ba_trp_v_tgt_longt_spd_slniv);
        fun("ba_trp_v_tgt_lat_spd_slniv", ba_trp_v_tgt_lat_spd_slniv);
        fun("ba_trp_v_tgt_rlt_spd_slniv", ba_trp_v_tgt_rlt_spd_slniv);
        fun("ba_trp_is_tgt_prsnt_slniv", ba_trp_is_tgt_prsnt_slniv);
        fun("ba_trp_t_tgt_dur_tm_slniv", ba_trp_t_tgt_dur_tm_slniv);
        fun("ba_trp_indx_tgt_id_slniv", ba_trp_indx_tgt_id_slniv);
        fun("ba_trp_a_tgt_longt_accel_slniv", ba_trp_a_tgt_longt_accel_slniv);
        fun("ba_trp_a_tgt_lat_accel_slniv", ba_trp_a_tgt_lat_accel_slniv);
        fun("ba_trp_indx_tgt_typ_slniv", ba_trp_indx_tgt_typ_slniv);
        fun("ba_trp_is_tgt_new_slniv", ba_trp_is_tgt_new_slniv);
        fun("ba_trp_is_tgt_cutin_flag_slniv", ba_trp_is_tgt_cutin_flag_slniv);
        fun("ba_trp_is_esaa", ba_trp_is_esaa);
        fun("ba_trp_indx_trp_lgt_sts", ba_trp_indx_trp_lgt_sts);
        fun("ba_trp_d_blue_crrdr_dist", ba_trp_d_blue_crrdr_dist);
        fun("ba_trp_v_blue_crrdr_spd", ba_trp_v_blue_crrdr_spd);
        fun("ba_trp_v_trgt_spd", ba_trp_v_trgt_spd);
        fun("ba_trp_d_related_dist_of_trgt_spd", ba_trp_d_related_dist_of_trgt_spd);
        fun("ba_trp_d_yllw_brdr_dist", ba_trp_d_yllw_brdr_dist);
        fun("ba_trp_v_yllw_brdr_spd", ba_trp_v_yllw_brdr_spd);
        fun("ba_trp_d_red_brdr_dist", ba_trp_d_red_brdr_dist);
        fun("ba_trp_v_red_brdr_spd", ba_trp_v_red_brdr_spd);
        fun("ba_trp_indx_blue_crrdr_tgt_id", ba_trp_indx_blue_crrdr_tgt_id);
        fun("ba_trp_is_blue_crrdr_obj_exist", ba_trp_is_blue_crrdr_obj_exist);
        fun("ba_trp_indx_opt_action", ba_trp_indx_opt_action);
    }

    friend bool operator==(const ::dpc::Decision4Long& lhs, const ::dpc::Decision4Long& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.ba_trp_d_lne_view_rngl - rhs.ba_trp_d_lne_view_rngl)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_lne_view_rngr - rhs.ba_trp_d_lne_view_rngr)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_indx_c2_lne_l - rhs.ba_trp_indx_c2_lne_l)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_indx_c2_lne_r - rhs.ba_trp_indx_c2_lne_r)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_indx_c3_lne_l - rhs.ba_trp_indx_c3_lne_l)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_indx_c3_lne_r - rhs.ba_trp_indx_c3_lne_r)) < DBL_EPSILON) && (lhs.ba_trp_indx_spdlim_typ == rhs.ba_trp_indx_spdlim_typ) && (fabs(static_cast<double>(lhs.ba_trp_kmh_spdlim_act_val - rhs.ba_trp_kmh_spdlim_act_val)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_spdlim_nxt_dst - rhs.ba_trp_d_spdlim_nxt_dst)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_t_tm_gap_actu - rhs.ba_trp_t_tm_gap_actu)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_sv_setspd - rhs.ba_trp_v_sv_setspd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_longt_dist_iv - rhs.ba_trp_d_tgt_longt_dist_iv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_lat_dist_iv - rhs.ba_trp_d_tgt_lat_dist_iv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_longt_spd_iv - rhs.ba_trp_v_tgt_longt_spd_iv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_lat_spd_iv - rhs.ba_trp_v_tgt_lat_spd_iv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_rlt_spd_iv - rhs.ba_trp_v_tgt_rlt_spd_iv)) < DBL_EPSILON) && (lhs.ba_trp_is_tgt_prsnt_iv == rhs.ba_trp_is_tgt_prsnt_iv) && (fabs(static_cast<double>(lhs.ba_trp_t_tgt_dur_tm_iv - rhs.ba_trp_t_tgt_dur_tm_iv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_id_iv == rhs.ba_trp_indx_tgt_id_iv) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_longt_accel_iv - rhs.ba_trp_a_tgt_longt_accel_iv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_lat_accel_iv - rhs.ba_trp_a_tgt_lat_accel_iv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_typ_iv == rhs.ba_trp_indx_tgt_typ_iv) && (lhs.ba_trp_is_tgt_new_iv == rhs.ba_trp_is_tgt_new_iv) && (lhs.ba_trp_is_tgt_lne_chg_flag_iv == rhs.ba_trp_is_tgt_lne_chg_flag_iv) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_longt_dist_iiv - rhs.ba_trp_d_tgt_longt_dist_iiv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_lat_dist_iiv - rhs.ba_trp_d_tgt_lat_dist_iiv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_longt_spd_iiv - rhs.ba_trp_v_tgt_longt_spd_iiv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_lat_spd_iiv - rhs.ba_trp_v_tgt_lat_spd_iiv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_rlt_spd_iiv - rhs.ba_trp_v_tgt_rlt_spd_iiv)) < DBL_EPSILON) && (lhs.ba_trp_is_tgt_prsnt_iiv == rhs.ba_trp_is_tgt_prsnt_iiv) && (fabs(static_cast<double>(lhs.ba_trp_t_tgt_dur_tm_iiv - rhs.ba_trp_t_tgt_dur_tm_iiv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_id_iiv == rhs.ba_trp_indx_tgt_id_iiv) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_longt_accel_iiv - rhs.ba_trp_a_tgt_longt_accel_iiv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_lat_accel_iiv - rhs.ba_trp_a_tgt_lat_accel_iiv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_typ_iiv == rhs.ba_trp_indx_tgt_typ_iiv) && (lhs.ba_trp_is_tgt_new_iiv == rhs.ba_trp_is_tgt_new_iiv) && (lhs.ba_trp_is_tgt_lne_chg_flag_iiv == rhs.ba_trp_is_tgt_lne_chg_flag_iiv) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_longt_dist_flniv - rhs.ba_trp_d_tgt_longt_dist_flniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_lat_dist_flniv - rhs.ba_trp_d_tgt_lat_dist_flniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_longt_spd_flniv - rhs.ba_trp_v_tgt_longt_spd_flniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_lat_spd_flniv - rhs.ba_trp_v_tgt_lat_spd_flniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_rlt_spd_flniv - rhs.ba_trp_v_tgt_rlt_spd_flniv)) < DBL_EPSILON) && (lhs.ba_trp_is_tgt_prsnt_flniv == rhs.ba_trp_is_tgt_prsnt_flniv) && (fabs(static_cast<double>(lhs.ba_trp_t_tgt_dur_tm_flniv - rhs.ba_trp_t_tgt_dur_tm_flniv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_id_flniv == rhs.ba_trp_indx_tgt_id_flniv) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_longt_accel_flniv - rhs.ba_trp_a_tgt_longt_accel_flniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_lat_accel_flniv - rhs.ba_trp_a_tgt_lat_accel_flniv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_typ_flniv == rhs.ba_trp_indx_tgt_typ_flniv) && (lhs.ba_trp_is_tgt_new_flniv == rhs.ba_trp_is_tgt_new_flniv) && (lhs.ba_trp_is_tgt_cutin_flag_flniv == rhs.ba_trp_is_tgt_cutin_flag_flniv) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_longt_dist_slniv - rhs.ba_trp_d_tgt_longt_dist_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_tgt_lat_dist_slniv - rhs.ba_trp_d_tgt_lat_dist_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_longt_spd_slniv - rhs.ba_trp_v_tgt_longt_spd_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_lat_spd_slniv - rhs.ba_trp_v_tgt_lat_spd_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_tgt_rlt_spd_slniv - rhs.ba_trp_v_tgt_rlt_spd_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_is_tgt_prsnt_slniv - rhs.ba_trp_is_tgt_prsnt_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_t_tgt_dur_tm_slniv - rhs.ba_trp_t_tgt_dur_tm_slniv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_id_slniv == rhs.ba_trp_indx_tgt_id_slniv) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_longt_accel_slniv - rhs.ba_trp_a_tgt_longt_accel_slniv)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_a_tgt_lat_accel_slniv - rhs.ba_trp_a_tgt_lat_accel_slniv)) < DBL_EPSILON) && (lhs.ba_trp_indx_tgt_typ_slniv == rhs.ba_trp_indx_tgt_typ_slniv) && (lhs.ba_trp_is_tgt_new_slniv == rhs.ba_trp_is_tgt_new_slniv) && (lhs.ba_trp_is_tgt_cutin_flag_slniv == rhs.ba_trp_is_tgt_cutin_flag_slniv) && (lhs.ba_trp_is_esaa == rhs.ba_trp_is_esaa) && (lhs.ba_trp_indx_trp_lgt_sts == rhs.ba_trp_indx_trp_lgt_sts) && (fabs(static_cast<double>(lhs.ba_trp_d_blue_crrdr_dist - rhs.ba_trp_d_blue_crrdr_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_blue_crrdr_spd - rhs.ba_trp_v_blue_crrdr_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_trgt_spd - rhs.ba_trp_v_trgt_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_related_dist_of_trgt_spd - rhs.ba_trp_d_related_dist_of_trgt_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_yllw_brdr_dist - rhs.ba_trp_d_yllw_brdr_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_yllw_brdr_spd - rhs.ba_trp_v_yllw_brdr_spd)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_d_red_brdr_dist - rhs.ba_trp_d_red_brdr_dist)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_trp_v_red_brdr_spd - rhs.ba_trp_v_red_brdr_spd)) < DBL_EPSILON) && (lhs.ba_trp_indx_blue_crrdr_tgt_id == rhs.ba_trp_indx_blue_crrdr_tgt_id) && (lhs.ba_trp_is_blue_crrdr_obj_exist == rhs.ba_trp_is_blue_crrdr_obj_exist) && (lhs.ba_trp_indx_opt_action == rhs.ba_trp_indx_opt_action);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_DECISION4LONG_H
